
AnimSprite = Core.class( Sprite )

function AnimSprite:init( texture, screenW, screenH )

	local bitmap = Bitmap.new( Texture.new(texture) )
	bitmap:setAnchorPoint( 0.5, 0.5 )
	self:addChild( bitmap )

	self.screenW = screenW
	self.screenH = screenH
	self.outofbound = 32

	self.xdirection = 1
	self.ydirection = 1
	
	self.xspeed = math.random( -100, 100 ) / 40
	self.yspeed = math.random( -100, 100 ) / 40
	
	self:setX( math.random(screenW) )
	self:setY( math.random(screenH) )
	
	self.rotrate = math.random( -5, 5 )	
	self:setRotation( math.random(360) )
	
	self.scalerate = 0.02
	self.scaledir = 1
	self:setScale( math.random(0.5, 2) )

	self:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)	
end


function AnimSprite:onEnterFrame(event)

	local rot = self:getRotation() + self.rotrate
	
	if rot > 360 or rot < -360 then
		rot = self.rotrate
	end
		
	self:setRotation( rot )

	local x, y = self:getPosition()

	x = x + self.xspeed * self.xdirection
	y = y + self.yspeed * self.ydirection
	
	if x < -self.outofbound then
		self.xdirection = 1
	end
		
	if x > self.screenW + self.outofbound then
		self.xdirection = -1
	end

	if y < -self.outofbound then
		self.ydirection = 1
	end
		
	if y > self.screenH + self.outofbound then
		self.ydirection = -1
	end

	self:setPosition( x, y )
	
	local scale = self:getScale() + self.scalerate * self.scaledir
	
	if scale > 2 then
		scale = 2
		self.scaledir = -1
	elseif scale < 0.5 then
		scale = 0.5
		self.scaledir = 1
	end
	
	self:setScale( scale )
end