local NUM_SPRITES = 200		-- for the player running on devices
local NUM_SPRITES = 2000	-- for the player running on desktop
local INCREMENT = 100		-- for adding/removing invisible sprites

-- set background to black
stage:setBackgroundColor( 0, 0, 0 )
stage:setOrientation( "landscapeLeft" )

local screenH = application:getDeviceWidth()
local screenW = application:getDeviceHeight()
print( "*** screen size = [" .. screenW .. ", " .. screenH .. "]" ) 

-- and add ball sprites to the stage
for i = 1, NUM_SPRITES do
    local sprite = AnimSprite.new( "Images/blowfish.png", screenW, screenH )
	stage:addChild( sprite )
end

local plus1 = Bitmap.new( Texture.new("Images/plus1.png") )
plus1:setAnchorPoint( 0.5, 0.5 )
plus1:setScale( 1.5 )
plus1:setAlpha( 0.2 )
local plus2 = Bitmap.new( Texture.new("Images/plus2.png") )
plus2:setAnchorPoint( 0.5, 0.5 )
plus2:setScale( 1.5 )
plus2:setAlpha( 0.4 )
local plusButton = Button.new( plus1, plus2 )
plusButton:setPosition( screenW - 200, screenH/2 )
stage:addChild( plusButton )

local ghosts = {}

plusButton:addEventListener( "click",
	function()
		for i = #ghosts + 1, #ghosts + INCREMENT do
		    local ghost = AnimSprite.new( "Images/blowfish.png", screenW, screenH )
			ghost:setAlpha( 0.02 )		-- ghostly sprite
			stage:addChild( ghost )
			ghosts[i] = ghost
		end
		print( "*** After being added, ghosts: " .. #ghosts )
	end
)

local minus1 = Bitmap.new( Texture.new("Images/minus1.png") )
minus1:setAnchorPoint( 0.5, 0.5 )
minus1:setScale( 1.5 )
minus1:setAlpha( 0.2 )
local minus2 = Bitmap.new( Texture.new("Images/minus2.png") )
minus2:setAnchorPoint( 0.5, 0.5 )
minus2:setScale( 1.5 )
minus2:setAlpha( 0.4 )
local minusButton = Button.new( minus1, minus2 )
minusButton:setPosition( 200, screenH/2 )
stage:addChild( minusButton )

minusButton:addEventListener( "click",
	function()
		if #ghosts > 0 then
			for i = #ghosts - INCREMENT + 1, #ghosts do
				stage:removeChild( ghosts[i] )
				ghosts[i] = nil
			end
			collectgarbage( "collect" )		
			print( "*** After being removed, ghosts: " .. #ghosts ) 
		end
	end
)

local font1 = TTFont.new( "Fonts/arial.ttf", 48 )
local text1 = TextField.new( font1, "Gideros Benchmark" )
text1:setTextColor( 0xFFFF00 )
text1:setPosition( 20, 70 )
stage:addChild( text1 )

local font2 = TTFont.new( "Fonts/arial.ttf", 32 )
local text2 = TextField.new( font2 )
text2:setTextColor( 0xFFFF00 )
text2:setPosition( 20, screenH - 40 )
stage:addChild( text2 )

local frames = 0
local t0 = os.time()	-- in seconds
local fps = 60			-- expected

local function displayFPS( event )
	frames = frames + 1
	if t0 ~= os.time() then
		fps = frames
		t0 = os.time()
		frames = 0
	end 
	local numSprites = stage:getNumChildren() - 4
	text2:setText( "Sprites: " .. numSprites .. "   FPS: " .. fps )
end

stage:addEventListener( Event.ENTER_FRAME, displayFPS )
